/**
 * geis.h
 *
 * Blah blah blah copyright blah license blah.
 */
#ifndef GEIS_GEIS_H_
#define GEIS_GEIS_H_

#define GEIS_VERSION_1_0  1

#include <geis/geisimpl.h>

/**
 * Errors returned from calls.
 */
typedef enum GeisStatus
{
	GEIS_STATUS_SUCCESS   = 0,
	GEIS_BAD_ARGUMENT     = 1000,
	GEIS_UNKNOWN_ERROR    = 9999
} GeisStatus;

typedef struct _GeisInstance *GeisInstance;

typedef struct GeisWinInfo
{
	int   win_type;
	void *win_info;
} GeisWinInfo;


/**
 * Gesture recognition instance control
 */
GeisStatus geis_init(GeisWinInfo *win_info, GeisInstance *geis_instance);

GeisStatus geis_finish(GeisInstance  geis_instance);

/**
 * Input devices.
 */

/**
 * Poosible actions from the input driver.
 */
typedef unsigned int GeisInputDeviceId;

#define GEIS_ALL_INPUT_DEVICES ((GeisInputDeviceId)0)

typedef enum GeisInputAction
{
	GEIS_INPUT_ADDED,
	GEIS_INPUT_CHANGED,
	GEIS_INPUT_REMOVED
} GeisInputAction;

typedef void (*GeisInputCallback)(void             *cookie,
                                  GeisInputAction   action,
                                  GeisInputDeviceId device_id,
                                  void             *attrs);

GeisStatus geis_input_devices(GeisInstance       geis_instance,
                              GeisInputCallback  callback,
                              void              *cookie);

/**
 * Gesture subscription
 */
typedef unsigned int GeisGestureType;
typedef unsigned int GeisGestureId;

#define GEIS_ALL_GESTURES ((GeisGestureType)0)
#define GEIS_NO_GESTURE_ID ((GeisGestureId)0)

typedef enum GeisGestureAction
{
	GEIS_GESTURE_ADDED,
	GEIS_GESTURE_REMOVED,
	GEIS_GESTURE_STARTED,
	GEIS_GESTURE_UPDATED,
	GEIS_GESTURE_FINISHED
} GeisGestureAction;

typedef void (*GeisGestureCallback)(void              *cookie,
                                    GeisGestureAction  action,
                                    GeisGestureType    gesture_type,
                                    GeisGestureId      gesture_id,
                                    void*             *attrs);

GeisStatus geis_subscribe(GeisInstance         geis_instance,
                          GeisInputDeviceId   *input_list,
                          const char*         *gesture_list,
                          GeisGestureCallback  callback,
                          void                *cookie);

GeisStatus geis_unsubscribe(GeisInstance     geis_instance,
														GeisGestureType *gesture_list);

#endif /* GEIS_GEIS_H_ */
